
// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "kcoreaddons_python.h"

// main header
#include "kusergroup_wrapper.h"

// Argument includes
#include <QList>
#include <QString>
#include <QStringList>
#include <kuser.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_KUserGroup_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::KUserGroup >()))
        return -1;

    ::KUserGroup *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);

    if (PyArg_ParseTuple(args, "|O:KUserGroup", &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: KUserGroup::KUserGroup(KGroupId)
    // 1: KUserGroup::KUserGroup(KUser::UIDMode=)
    // 2: KUserGroup::KUserGroup(KUserGroup)
    // 3: KUserGroup::KUserGroup(QString)
    // 4: KUserGroup::KUserGroup(const char*)
    // 5: KUserGroup::KUserGroup(uint)
    if (numArgs == 0) {
        overloadId = 1; // KUserGroup(KUser::UIDMode)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]), (pyArgs[0])))) {
        overloadId = 2; // KUserGroup(KUserGroup)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KUser_UIDMode_IDX])))->converter, (pyArgs[0])))) {
        overloadId = 1; // KUserGroup(KUser::UIDMode)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<const char *>(), (pyArgs[0])))) {
        overloadId = 4; // KUserGroup(const char*)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        overloadId = 3; // KUserGroup(QString)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned int>(), (pyArgs[0])))) {
        overloadId = 5; // KUserGroup(uint)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX]), (pyArgs[0])))) {
        overloadId = 0; // KUserGroup(KGroupId)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // KUserGroup(KGroupId gid)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::KGroupId *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // KUserGroup(KGroupId)
                cptr = new ::KUserGroup(*cppArg0);
            }
            break;
        }
        case 1: // KUserGroup(KUser::UIDMode mode)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_mode = Shiboken::String::createStaticString("mode");
                if (PyDict_Contains(kwds, key_mode) != 0) {
                    value = PyDict_GetItem(kwds, key_mode);
                    if (value != nullptr && pyArgs[0] != nullptr ) {
                        errInfo.reset(key_mode);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
                    }
                    if (value != nullptr) {
                        pyArgs[0] = value;
                        if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KUser_UIDMode_IDX])))->converter, (pyArgs[0]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
                    }
                    PyDict_DelItem(kwds_dup, key_mode);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
                }
            }
            ::KUser::UIDMode cppArg0(KUser::UseEffectiveUID);
            if (pythonToCpp[0])
                pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // KUserGroup(KUser::UIDMode)
                cptr = new ::KUserGroup(cppArg0);
            }
            break;
        }
        case 2: // KUserGroup(const KUserGroup &group)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::KUserGroup *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // KUserGroup(KUserGroup)
                cptr = new ::KUserGroup(*cppArg0);
            }
            break;
        }
        case 3: // KUserGroup(const QString &name)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
            }
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // KUserGroup(QString)
                cptr = new ::KUserGroup(cppArg0);
            }
            break;
        }
        case 4: // KUserGroup(const char *name)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
            }
            const char* cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // KUserGroup(const char*)
                cptr = new ::KUserGroup(cppArg0);
            }
            break;
        }
        case 5: // KUserGroup(unsigned int gid)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
            }
            unsigned int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // KUserGroup(uint)
                cptr = new ::KUserGroup(cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::KUserGroup >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_KUserGroupFunc_allGroupNames(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "allGroupNames", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);

    if (PyArg_ParseTuple(args, "|O:allGroupNames", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static KUserGroup::allGroupNames(uint=)->QStringList
    if (numArgs == 0) {
        overloadId = 0; // allGroupNames(uint)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArgs[0])))) {
        overloadId = 0; // allGroupNames(uint)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "allGroupNames", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_maxCount = Shiboken::String::createStaticString("maxCount");
            if (PyDict_Contains(kwds, key_maxCount) != 0) {
                value = PyDict_GetItem(kwds, key_maxCount);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_maxCount);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "allGroupNames", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, "allGroupNames", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_maxCount);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "allGroupNames", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
            }
        }
        uint cppArg0 = KCOREADDONS_UINT_MAX;
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // allGroupNames(uint)
            QStringList cppResult = ::KUserGroup::allGroupNames(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KUserGroupFunc_allGroups(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "allGroups", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);

    if (PyArg_ParseTuple(args, "|O:allGroups", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static KUserGroup::allGroups(uint=)->QList<KUserGroup>
    if (numArgs == 0) {
        overloadId = 0; // allGroups(uint)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArgs[0])))) {
        overloadId = 0; // allGroups(uint)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "allGroups", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_maxCount = Shiboken::String::createStaticString("maxCount");
            if (PyDict_Contains(kwds, key_maxCount) != 0) {
                value = PyDict_GetItem(kwds, key_maxCount);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_maxCount);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "allGroups", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, "allGroups", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_maxCount);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "allGroups", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
            }
        }
        uint cppArg0 = KCOREADDONS_UINT_MAX;
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // allGroups(uint)
            QList<KUserGroup> cppResult = ::KUserGroup::allGroups(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkKCoreAddonsTypeConverters[SBK_KCoreAddons_QList_KUserGroup_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KUserGroupFunc_groupId(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KUserGroup *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // groupId()const
            KGroupId* cppResult = new KGroupId(const_cast<const ::KUserGroup *>(cppSelf)->groupId());
            pyResult = Shiboken::Object::newObject(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KGroupId_IDX]), cppResult, true, true);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KUserGroupFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KUserGroup *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::KUserGroup *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KUserGroupFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KUserGroup *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            QString cppResult = const_cast<const ::KUserGroup *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KUserGroupFunc_userNames(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KUserGroup *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "userNames", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);

    if (PyArg_ParseTuple(args, "|O:userNames", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: KUserGroup::userNames(uint=)const->QStringList
    if (numArgs == 0) {
        overloadId = 0; // userNames(uint)const
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArgs[0])))) {
        overloadId = 0; // userNames(uint)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "userNames", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_maxCount = Shiboken::String::createStaticString("maxCount");
            if (PyDict_Contains(kwds, key_maxCount) != 0) {
                value = PyDict_GetItem(kwds, key_maxCount);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_maxCount);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "userNames", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, "userNames", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_maxCount);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "userNames", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
            }
        }
        uint cppArg0 = KCOREADDONS_UINT_MAX;
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // userNames(uint)const
            QStringList cppResult = const_cast<const ::KUserGroup *>(cppSelf)->userNames(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_KUserGroupFunc_users(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::KUserGroup *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, "users", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);

    if (PyArg_ParseTuple(args, "|O:users", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: KUserGroup::users(uint=)const->QList<KUser>
    if (numArgs == 0) {
        overloadId = 0; // users(uint)const
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArgs[0])))) {
        overloadId = 0; // users(uint)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, "users", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_maxCount = Shiboken::String::createStaticString("maxCount");
            if (PyDict_Contains(kwds, key_maxCount) != 0) {
                value = PyDict_GetItem(kwds, key_maxCount);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_maxCount);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, "users", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<uint>(), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, "users", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
                }
                PyDict_DelItem(kwds_dup, key_maxCount);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, "users", errInfo, SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]);
            }
        }
        uint cppArg0 = KCOREADDONS_UINT_MAX;
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // users(uint)const
            QList<KUser> cppResult = const_cast<const ::KUserGroup *>(cppSelf)->users(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkKCoreAddonsTypeConverters[SBK_KCoreAddons_QList_KUser_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_KUserGroup_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_KUserGroup_methods[] = {
    {"allGroupNames", reinterpret_cast<PyCFunction>(Sbk_KUserGroupFunc_allGroupNames), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"allGroups", reinterpret_cast<PyCFunction>(Sbk_KUserGroupFunc_allGroups), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"groupId", reinterpret_cast<PyCFunction>(Sbk_KUserGroupFunc_groupId), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_KUserGroupFunc_isValid), METH_NOARGS, nullptr},
    {"name", reinterpret_cast<PyCFunction>(Sbk_KUserGroupFunc_name), METH_NOARGS, nullptr},
    {"userNames", reinterpret_cast<PyCFunction>(Sbk_KUserGroupFunc_userNames), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"users", reinterpret_cast<PyCFunction>(Sbk_KUserGroupFunc_users), METH_VARARGS|METH_KEYWORDS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_KUserGroup_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::KUserGroup *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]), (pyArg)))) {
                // operator!=(const KUserGroup &group) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::KUserGroup *cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX]), (pyArg)))) {
                // operator==(const KUserGroup &group) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::KUserGroup *cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_KUserGroup_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_KUserGroup_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_KUserGroup_Type = nullptr;
static PyTypeObject *Sbk_KUserGroup_TypeF(void)
{
    return _Sbk_KUserGroup_Type;
}

static PyType_Slot Sbk_KUserGroup_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_KUserGroup_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_KUserGroup_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_KUserGroup_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_KUserGroup_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_KUserGroup_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_KUserGroup_spec = {
    "1:KCoreAddons.KUserGroup",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_KUserGroup_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void KUserGroup_PythonToCpp_KUserGroup_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_KUserGroup_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_KUserGroup_PythonToCpp_KUserGroup_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_KUserGroup_TypeF()))
        return KUserGroup_PythonToCpp_KUserGroup_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *KUserGroup_PTR_CppToPython_KUserGroup(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_KUserGroup_TypeF(), const_cast<void *>(cppIn), false);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *KUserGroup_SignatureStrings[] = {
    "5:KCoreAddons.KUserGroup(self,gid:KCoreAddons.KGroupId)",
    "4:KCoreAddons.KUserGroup(self,mode:KCoreAddons.KUser.UIDMode=KUser.UseEffectiveUID)",
    "3:KCoreAddons.KUserGroup(self,group:KCoreAddons.KUserGroup)",
    "2:KCoreAddons.KUserGroup(self,name:QString)",
    "1:KCoreAddons.KUserGroup(self,name:char*)",
    "0:KCoreAddons.KUserGroup(self,gid:unsigned int)",
    "KCoreAddons.KUserGroup.allGroupNames(maxCount:uint=KCOREADDONS_UINT_MAX)->QStringList",
    "KCoreAddons.KUserGroup.allGroups(maxCount:uint=KCOREADDONS_UINT_MAX)->QList[KCoreAddons.KUserGroup]",
    "KCoreAddons.KUserGroup.groupId(self)->KCoreAddons.KGroupId",
    "KCoreAddons.KUserGroup.isValid(self)->bool",
    "KCoreAddons.KUserGroup.name(self)->QString",
    "KCoreAddons.KUserGroup.userNames(self,maxCount:uint=KCOREADDONS_UINT_MAX)->QStringList",
    "KCoreAddons.KUserGroup.users(self,maxCount:uint=KCOREADDONS_UINT_MAX)->QList[KCoreAddons.KUser]",
    nullptr}; // Sentinel
#else
static constexpr size_t KUserGroup_SignatureByteSize = 257;
static constexpr uint8_t KUserGroup_SignatureBytes[257] = {
    0x78, 0xda, 0xad, 0x92, 0x5b, 0x4b, 0xc4, 0x30, 0x10, 0x85, 0xdf, 0xf3, 0x2b, 0x7c, 0xdc, 0x88,
    0x16, 0xaf, 0x2f, 0x85, 0x15, 0x4a, 0xbb, 0x48, 0xa9, 0xdb, 0x45, 0xd7, 0x8a, 0xb0, 0x2c, 0x4b,
    0xdc, 0x4c, 0x6b, 0x20, 0x4d, 0x24, 0x17, 0xf1, 0xe7, 0x9b, 0x5e, 0x14, 0xc4, 0xa6, 0x75, 0xc1,
    0xb7, 0x09, 0x73, 0xce, 0x97, 0x99, 0x93, 0x5c, 0x87, 0x59, 0x2c, 0x15, 0x44, 0x94, 0x4a, 0xa1,
    0x83, 0xac, 0xd0, 0xa0, 0x6e, 0x95, 0xb4, 0x6f, 0x33, 0x0d, 0xbc, 0x3c, 0xa9, 0x18, 0xfd, 0xd9,
    0x6f, 0x7b, 0x29, 0xc5, 0xe8, 0x6a, 0xd4, 0x57, 0x4b, 0x0a, 0xbf, 0x05, 0x41, 0x91, 0x26, 0x4b,
    0xd7, 0x99, 0xf7, 0x27, 0x0d, 0x8b, 0xb2, 0x84, 0xbd, 0x61, 0xef, 0xe0, 0x3a, 0x18, 0x5d, 0x8e,
    0xcf, 0xd2, 0x94, 0x1e, 0x05, 0x46, 0x17, 0xa3, 0x5e, 0x41, 0x6a, 0x08, 0xef, 0xd7, 0x46, 0x31,
    0x51, 0x61, 0x74, 0x3e, 0xad, 0xdd, 0xbf, 0x12, 0x75, 0x8c, 0xd1, 0xd9, 0x64, 0x3a, 0x56, 0x68,
    0x56, 0x09, 0xa0, 0x47, 0x4c, 0x18, 0x8c, 0x86, 0xd5, 0x01, 0xe1, 0xbc, 0x2d, 0x72, 0x87, 0xd6,
    0xb3, 0x9a, 0x7c, 0xc4, 0xd2, 0x0a, 0x13, 0x5a, 0xe7, 0x99, 0x67, 0xf1, 0xea, 0x61, 0x11, 0x25,
    0xc9, 0x2a, 0x5f, 0xef, 0x8a, 0x34, 0x7f, 0xdc, 0x2d, 0xa3, 0x67, 0x7c, 0x7a, 0xd3, 0x0f, 0x7b,
    0xc7, 0xb4, 0x99, 0xa2, 0xfe, 0x95, 0xd8, 0xb0, 0x36, 0xc3, 0xac, 0xad, 0xef, 0x8e, 0xaa, 0x7b,
    0xef, 0x76, 0x5f, 0xc7, 0x18, 0xfa, 0x0b, 0x3e, 0x2b, 0xd3, 0x4f, 0x84, 0xb3, 0x6f, 0xeb, 0x8b,
    0x94, 0xdc, 0x27, 0x6d, 0x22, 0xff, 0xd2, 0xf5, 0x8b, 0xfb, 0xa4, 0xd6, 0x55, 0x5d, 0x8c, 0xdd,
    0x47, 0xfb, 0xa7, 0x2c, 0x1b, 0xec, 0x41, 0xc8, 0xe1, 0x30, 0xb7, 0xe8, 0x13, 0xbd, 0x9c, 0x2c,
    0xea
};
#endif

PyTypeObject *init_KUserGroup(PyObject *module)
{
    if (SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX].type != nullptr)
        return SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX].type;

    Shiboken::AutoDecRef Sbk_KUserGroup_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_KUserGroup_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "KUserGroup",
        "KUserGroup*",
        &Sbk_KUserGroup_spec,
        &Shiboken::callCppDestructor< ::KUserGroup >,
        Sbk_KUserGroup_Type_bases.object(),
        0);
    auto *pyType = Sbk_KUserGroup_TypeF(); // references _Sbk_KUserGroup_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, KUserGroup_SignatureStrings);
#else
    InitSignatureBytes(pyType, KUserGroup_SignatureBytes, KUserGroup_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_KUserGroup_PropertyStrings);
    SbkKCoreAddonsTypeStructs[SBK_KUserGroup_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        KUserGroup_PythonToCpp_KUserGroup_PTR,
        is_KUserGroup_PythonToCpp_KUserGroup_PTR_Convertible,
        KUserGroup_PTR_CppToPython_KUserGroup);

    Shiboken::Conversions::registerConverterName(converter, "KUserGroup");
    Shiboken::Conversions::registerConverterName(converter, "KUserGroup*");
    Shiboken::Conversions::registerConverterName(converter, "KUserGroup&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::KUserGroup).name());

    qRegisterMetaType< ::KUserGroup *>();

    return pyType;
}
